﻿Imports System.Net.Sockets
Imports System.Timers

Module Module1
    Public Client As UdpClient
    Public RemoteIpEndPoint As New System.Net.IPEndPoint(System.Net.IPAddress.Any, 0) 'any ip we dont care
    Public ThreadReceive As System.Threading.Thread
    Public MyPort As Integer = 19999 ' source UDP port

    'Output Vars
    Public Roll_Output As Double = 0
    Public Pitch_Output As Double = 0
    Public Heave_Output As Double = 0
    Public Yaw_Output As Double = 0
    Public Sway_Output As Double = 0
    Public Surge_Output As Double = 0


    'Used by GameEngine to Process Incoming UDP Packets.
    Public Speed_Input As Double = 0
    Public Turn_Input As Double = 0
    Public AngSpeed_Input As Double = 0
    Public Azimuth_Input As Double = 0
    Public BeacAzim_Input As Double = 0
    Public Roll_Input As Double = 0
    Public Pitch_Input As Double = 0


    '
    Dim sendBytes As [Byte]() = System.Text.Encoding.ASCII.GetBytes("R/30/36/38/42/44/46/48")
    ' timer for sending request to game
    Dim tmr As New System.Timers.Timer()

    ' time event - sending to 21000 destinatopn port from 19999 port
    Private Sub OnTimedEvent(ByVal sender As Object, ByVal e As ElapsedEventArgs)
        Client.Send(sendBytes, sendBytes.Length, "localhost", 21000)

    End Sub


    Sub Main()
        'set client
        Client = New System.Net.Sockets.UdpClient(MyPort)
        'start thread loop
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.Start()
        'timer setting
        tmr.Interval = 50
        tmr.Enabled = True
        tmr.Start()
        AddHandler tmr.Elapsed, AddressOf OnTimedEvent
    End Sub


    Private Sub Process_PacketRecieved(Text As String)
        Dim MyText, tv As String
        Dim i, j As Integer

        'Clear Screen
        Console.Clear()

        'get only symbolic characters
        MyText = ""
        For i = 0 To Text.Length - 1
            If Text(i) > " " Then
                If Text(i) <= "}" Then
                    MyText = MyText + Text(i)
                End If
            End If
        Next

        ' extract data from received string (not optimized yet)
        i = InStr(MyText, "/30\")
        j = InStr(MyText, "/36\")
        Speed_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = InStr(MyText, "/38\")
        Turn_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = InStr(MyText, "/42\")
        AngSpeed_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = InStr(MyText, "/44\")
        Azimuth_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = InStr(MyText, "/46\")
        BeacAzim_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = InStr(MyText, "/48\")
        Roll_Input = Mid(MyText, i + 4, j - i - 4)

        i = j
        j = MyText.Length
        Pitch_Input = Mid(MyText, i + 4, j - i - 3)


        ''Show the raw data - Uncomment this section for IL-2
        Console.WriteLine("Raw Data Is:") 'title
        Console.WriteLine(MyText) 'Display Data - May get weird beeping if a structure is found - not sure why lol
        Console.WriteLine("")

        tv = Speed_Input
        Console.WriteLine("Speed_Input    = " + tv)
        tv = Turn_Input
        Console.WriteLine("Turn_Input     = " + tv)
        tv = AngSpeed_Input
        Console.WriteLine("AngSpeed_Input = " + tv)
        tv = Azimuth_Input
        Console.WriteLine("Azimuth_Input  = " + tv)
        tv = BeacAzim_Input
        Console.WriteLine("BeacAzim_Input = " + tv)
        tv = Roll_Input
        Console.WriteLine("Roll_Input     = " + tv)
        tv = Pitch_Input
        Console.WriteLine("Pitch_Input    = " + tv)


    End Sub

    Public Sub ReceiveMessages()
        Dim receiveBytes As [Byte]()

        ' IMPORTANT - Try to receive data. If Game is not started, called Exception
        Try

            receiveBytes = Client.Receive(RemoteIpEndPoint)
            Dim strReturnData As String = System.Text.Encoding.Default.GetString(receiveBytes)

            'returns the data as a string
            Process_PacketRecieved(strReturnData)

            'start new thread
        Catch ex As Exception
            'nothing to do

        Finally
            ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
            ThreadReceive.Start()


        End Try

    End Sub
End Module
